%define ALD_Ver		2.0

#USE gcc-5.5.0

%define OrgName ncurses
%define mC_Version 1.2.4s

Name:         mC-%{OrgName}
License:      GPL
Summary:      CRT screen handling and optimization package
Version:      5.9
Release:      %{mC_Version}.0

#ftp://invisible-island.net/ncurses/

%define src_patch_name %{OrgName}-%{version}-20141206-patch.sh

Source: %{OrgName}-%{version}.tar.xz
Source1: Add-static-lib.sh
Source2: %{src_patch_name}.xz
Source3: %{OrgName}-%{version}-patches.tgz

%define DestDir /Embedded/mC/%{mC_Version}
%define _prefix /usr/mC/%{mC_Version}

# -----------------------------------------------------
%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}/mC/%{mC_Version}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%endif

# -----------------------------------------------------

%if %{have_auto_local}
%define __os_install_post %{nil}
%else
%define MakeLocCross 0
%endif

%if %{_CROSS}
%define CrossPath /cross/%{_target_cpu}
%else
%define CrossPath %{nil}
%endif

#------------------ CROSS DIR --------------------

%define target %{_arch}-linux-musl
%define docdir %{_defaultdocdir}/%{OrgName}

# ------------------- description ------------------------------------
%description
CRT screen handling and optimization package
#-------------------------------
%package      %{_target_cpu}
Summary:      %{name} Cross-%{_target_cpu} Libraries
Buildarch:    noarch
autoreqprov:  0
%description  %{_target_cpu}
%{name} Cross-%{_target_cpu} Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{OrgName}-%{version}
cp %SOURCE2 ./
xz -d %{src_patch_name}.xz
bash %{src_patch_name}
rm %{src_patch_name}

tar -xaf %SOURCE3

patch -p1<patches/cve-fixes.diff
patch -p1<patches/termcap-fix.diff
patch -p1<patches/more-cve-fixes.diff
patch -p1<patches/cve-2017-13733.diff
patch -p1<patches/cve-2017-16879.diff
patch -p0<patches/ncurses-config.patche

# ------------------- Build ------------------------------------------
%Build
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -Os -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables -ffunction-sections -fdata-sections"
export CFLAGS="$OPTFLAGS"
export LDFLAGS="-Wl,--gc-sections"
export CC="%{target}-gcc"
#export AR="%{target}-ar"
#export AR="%{target}-ar -curv"
#export RANLIB="%{target}-ranlib"

mkdir _Build
cd _Build
ln -s ../configure .

./configure \
%if %{_CROSS}
	--build=%{_build} \
	--host=%{target} \
%endif
	--prefix=%{_prefix} \
	--exec-prefix=%{_exec_prefix} \
	--libdir=%{_libdir} \
	--includedir=%{_includedir} \
	--without-shared \
	--with-normal \
	--without-profile --without-debug \
	--without-cxx \
	--without-cxx-binding \
	--without-ada \
	--disable-lp64 \
	--with-ospeed=unsigned \
	--disable-rpath \
	--disable-home-terminfo \
	--disable-rpath-hack \
	--enable-overwrite \
	--with-termlib=tinfo \
	--with-pkg-config=/usr/bin/pkg-config \
	--with-pkg-config-libdir=%{_libdir}/pkgconfig \
	--enable-pc-files \
	--with-install-prefix=${RPM_BUILD_ROOT} \
	--with-terminfo-dirs=/usr/share/terminfo \
	--with-default-terminfo-dir=/usr/share/terminfo \
	--without-progs \
	--with-ticlib \
	&>FConfigure_log.txt

make V=1 &>Fmake_log.txt
cd ..

mkdir _Build_wc
cd _Build_wc
ln -s ../configure .

./configure \
%if %{_CROSS}
	--build=%{_build} \
	--host=%{target} \
%endif
	--prefix=%{_prefix} \
	--exec-prefix=%{_exec_prefix} \
	--libdir=%{_libdir} \
	--includedir=%{_includedir} \
	--without-shared \
	--with-normal \
	--without-profile --without-debug \
	--without-cxx \
	--without-cxx-binding \
	--without-ada \
	--disable-lp64 \
	--with-ospeed=unsigned \
	--disable-rpath \
	--disable-home-terminfo \
	--disable-rpath-hack \
	--enable-overwrite \
	--with-termlib=tinfo \
	--with-pkg-config=/usr/bin/pkg-config \
	--with-pkg-config-libdir=%{_libdir}/pkgconfig \
	--enable-pc-files \
	--with-install-prefix=${RPM_BUILD_ROOT} \
	--with-terminfo-dirs=/usr/share/terminfo \
	--with-default-terminfo-dir=/usr/share/terminfo \
	--without-progs \
	--enable-widec \
	&>Fconfigure_log_wc.txt

make V=1 libs &>Fmake_log_wc.txt
cd ..



# ------------------- Install ----------------------------------------
%Install
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make -C _Build DESTDIR=$RPM_BUILD_ROOT install.libs &>FInstall_log.txt
make -C _Build_wc DESTDIR=$RPM_BUILD_ROOT install.{libs,includes} &>FInstall_log_wc.txt
cp COPYING README $RPM_BUILD_ROOT%{docdir}/

cp $RPM_BUILD_ROOT/%{_libdir}/libtinfo.a $RPM_BUILD_ROOT/%{_libdir}/libtinfow.a
%SOURCE1 -TmpPath="/tmp/Add-static-lib-tmp" -clr_a -cp_a -ranlib \
 -LibPath="$RPM_BUILD_ROOT/%{_libdir}" -aname="libncurses.a" \
 -alib="libform.a libmenu.a libncurses.a libpanel.a"

%SOURCE1 -TmpPath="/tmp/Add-static-lib-tmp" -clr_a -cp_a -ranlib \
 -LibPath="$RPM_BUILD_ROOT/%{_libdir}" -aname="libncursesw.a" \
 -alib="libformw.a libmenuw.a libncursesw.a libpanelw.a"

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -target_platform=%{target}-
%if %{MakeLocCross}
  sed -i s:"=\"/usr":"=\"%{CrossPath}/usr": $RPM_BUILD_ROOT%{CrossPath}%{_bindir}/ncurses5-config
  sed -i s:"= /usr":"= %{CrossPath}/usr": $RPM_BUILD_ROOT%{CrossPath}%{_bindir}/ncurses5-config
%endif
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean
%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Cross Files ------------------------------------
%files
%{_prefix}

# ------------------- Cross Files ------------------------------------
%if %{MakeLocCross}

%files %{_target_cpu}
%{CrossPath}%{_prefix}

%endif # MakeLocCross
